import { BuildWorkflow } from 'projen/lib/build';
import { GitHubProject, GitHubProjectOptions } from 'projen/lib/github';
import { ButterneckAwsCdkPythonApp, ButterneckAwsCdkPythonAppOptions } from './awscdk-python-app';
import { GoProject, GoProjectOptions } from './go-project';
export interface GoAppOptions extends GitHubProjectOptions {
    /**
     * TODO
     *
     * @type {ButterneckAwsCdkPythonAppOptions}
     * @memberof GoAppOptions
     */
    readonly infra?: ButterneckAwsCdkPythonAppOptions;
    /**
     * TODO
     *
     * @type {GoProjectOptions}
     * @memberof GoAppOptions
     */
    readonly service?: GoProjectOptions;
    /**
     * Define a GitHub workflow for building PRs.
     * @default - true if not a subproject
     */
    readonly buildWorkflow?: boolean;
    /**
     * Automatically update files modified during builds to pull-request branches. This means
     * that any files synthesized by projen or e.g. test snapshots will always be up-to-date
     * before a PR is merged.
     *
     * Implies that PR builds do not have anti-tamper checks.
     *
     * @default true
     */
    readonly mutableBuild?: boolean;
}
/**
 * GoApp Project
 *
 * @export
 * @class GoApp
 * @extends {awscdk.AwsCdkPythonApp}
 * @pjid go-app
 */
export declare class GoApp extends GitHubProject {
    /**
     * TODO
     *
     * @type {ButterneckAwsCdkPythonApp}
     * @memberof GoApp
     */
    infra: ButterneckAwsCdkPythonApp;
    /**
     * TODO
     *
     * @type {GoProject}
     * @memberof GoApp
     */
    service: GoProject;
    /**
     * The PR build GitHub workflow. `undefined` if `buildWorkflow` is disabled.
     */
    readonly buildWorkflow?: BuildWorkflow;
    constructor(options: GoAppOptions);
}
